﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DemoLibrary
{
    public class DataObject
    {
        private readonly Dictionary<string, int> _values = new Dictionary<string, int>
        {
            ["A"] = 1,
            ["B"] = 2,
        };

        public string Name { get; }
        public string NameSize { get; }
        public char NameStart { get; }
        public Guid Id { get; } = Guid.NewGuid();
        public int Count { get; set; } = 1;

        public int CountSquared => Count * Count;

        public int CountMultiple(int multiplier) => Count * multiplier;

        public DataObject(string name)
        {
            Name = name;

            NameSize = Name?.Length.ToString() ?? "0";
            NameStart = Name?[0] ?? 'X';
        }

        public void WriteData()
        {
            Console.WriteLine("The data is \{Name} \{Id} \{Count}");

            WroteData?.Invoke(this, EventArgs.Empty);
        }

        public event EventHandler WroteData;
    }

    struct NoData
    {
        public NoData()
        {
        }
    }
}
