﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DemoLibrary
{
    class ViewModel : INotifyPropertyChanged
    {
        private int _total;
        public int Total
        {
            get
            {
                return _total;
            }
            set
            {
                if (_total == value)
                    return;
                _total = value;
                PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(nameof(Total)));
            }
        }

        public async Task Calculate()
        {
            LongOperation operation = new LongOperation();
            try
            {
                await operation.DoWork();
            }
            catch (ArgumentException ex) if (ex.ParamName == "ignoreMe") { }
            catch
            {
                await operation.Rollback();
            }
            finally
            {
                await operation.Close();
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }
}
